

# CreateMembers
<a name="API_CreateMembers"></a>

Creates member accounts of the current Amazon account by specifying a list of Amazon account IDs. This step is a prerequisite for managing the associated member accounts either by invitation or through an organization.

As a delegated administrator, using `CreateMembers` will enable GuardDuty in the added member accounts, with the exception of the organization delegated administrator account. A delegated administrator must enable GuardDuty prior to being added as a member.

When you use CreateMembers as an Amazon Organizations delegated administrator, GuardDuty applies your organization's auto-enable settings to the member accounts in this request, irrespective of the accounts being new or existing members. For more information about the existing auto-enable settings for your organization, see [DescribeOrganizationConfiguration](https://docs.amazonaws.cn/guardduty/latest/APIReference/API_DescribeOrganizationConfiguration.html).

If you disassociate a member account that was added by invitation, the member account details obtained from this API, including the associated email addresses, will be retained. This is done so that the delegated administrator can invoke the [InviteMembers](https://docs.amazonaws.cn/guardduty/latest/APIReference/API_InviteMembers.html) API without the need to invoke the CreateMembers API again. To remove the details associated with a member account, the delegated administrator must invoke the [DeleteMembers](https://docs.amazonaws.cn/guardduty/latest/APIReference/API_DeleteMembers.html) API. 

When the member accounts added through Amazon Organizations are later disassociated, you (administrator) can't invite them by calling the InviteMembers API. You can create an association with these member accounts again only by calling the CreateMembers API.

## Request Syntax
<a name="API_CreateMembers_RequestSyntax"></a>

```
POST /detector/{{DetectorId}}/member HTTP/1.1
Content-type: application/json

{
   "accountDetails": [ 
      { 
         "accountId": "{{string}}",
         "email": "{{string}}"
      }
   ]
}
```

## URI Request Parameters
<a name="API_CreateMembers_RequestParameters"></a>

The request uses the following URI parameters.

 ** [DetectorId](#API_CreateMembers_RequestSyntax) **   <a name="guardduty-CreateMembers-request-uri-DetectorId"></a>
The unique ID of the detector of the GuardDuty account for which you want to associate member accounts.  
To find the `detectorId` in the current Region, see the Settings page in the GuardDuty console, or run the [ListDetectors](https://docs.amazonaws.cn/guardduty/latest/APIReference/API_ListDetectors.html) API.  
Length Constraints: Minimum length of 1. Maximum length of 300.  
Required: Yes

## Request Body
<a name="API_CreateMembers_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [accountDetails](#API_CreateMembers_RequestSyntax) **   <a name="guardduty-CreateMembers-request-accountDetails"></a>
A list of account ID and email address pairs of the accounts that you want to associate with the GuardDuty administrator account.  
Type: Array of [AccountDetail](API_AccountDetail.md) objects  
Array Members: Minimum number of 1 item. Maximum number of 50 items.  
Required: Yes

## Response Syntax
<a name="API_CreateMembers_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "unprocessedAccounts": [ 
      { 
         "accountId": "string",
         "result": "string"
      }
   ]
}
```

## Response Elements
<a name="API_CreateMembers_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [unprocessedAccounts](#API_CreateMembers_ResponseSyntax) **   <a name="guardduty-CreateMembers-response-unprocessedAccounts"></a>
A list of objects that include the `accountIds` of the unprocessed accounts and a result string that explains why each was unprocessed.  
Type: Array of [UnprocessedAccount](API_UnprocessedAccount.md) objects  
Array Members: Minimum number of 0 items. Maximum number of 50 items.

## Errors
<a name="API_CreateMembers_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** BadRequestException **   
A bad request exception object.    
 ** Message **   
The error message.  
 ** Type **   
The error type.
HTTP Status Code: 400

 ** InternalServerErrorException **   
An internal server error exception object.    
 ** Message **   
The error message.  
 ** Type **   
The error type.
HTTP Status Code: 500

## See Also
<a name="API_CreateMembers_SeeAlso"></a>

For more information about using this API in one of the language-specific Amazon SDKs, see the following:
+  [Amazon Command Line Interface V2](https://docs.amazonaws.cn/goto/cli2/guardduty-2017-11-28/CreateMembers) 
+  [Amazon SDK for .NET V4](https://docs.amazonaws.cn/goto/DotNetSDKV4/guardduty-2017-11-28/CreateMembers) 
+  [Amazon SDK for C\+\+](https://docs.amazonaws.cn/goto/SdkForCpp/guardduty-2017-11-28/CreateMembers) 
+  [Amazon SDK for Go v2](https://docs.amazonaws.cn/goto/SdkForGoV2/guardduty-2017-11-28/CreateMembers) 
+  [Amazon SDK for Java V2](https://docs.amazonaws.cn/goto/SdkForJavaV2/guardduty-2017-11-28/CreateMembers) 
+  [Amazon SDK for JavaScript V3](https://docs.amazonaws.cn/goto/SdkForJavaScriptV3/guardduty-2017-11-28/CreateMembers) 
+  [Amazon SDK for Kotlin](https://docs.amazonaws.cn/goto/SdkForKotlin/guardduty-2017-11-28/CreateMembers) 
+  [Amazon SDK for PHP V3](https://docs.amazonaws.cn/goto/SdkForPHPV3/guardduty-2017-11-28/CreateMembers) 
+  [Amazon SDK for Python](https://docs.amazonaws.cn/goto/boto3/guardduty-2017-11-28/CreateMembers) 
+  [Amazon SDK for Ruby V3](https://docs.amazonaws.cn/goto/SdkForRubyV3/guardduty-2017-11-28/CreateMembers) 